local BTS = AceLibrary("Babble-Tradeskill-2.2")
local PT = AceLibrary("PeriodicTable-3.0")
GuildTradeSkills = AceLibrary("AceAddon-2.0"):new("AceComm-2.0", "AceEvent-2.0", "AceConsole-2.0", "FuBarPlugin-2.0")

local tradeSkills = {
	[BTS["Alchemy"]] = "Alchemy",
	[BTS["Blacksmithing"]] = "Blacksmithing",
	[BTS["Cooking"]] = "Cooking",
	[BTS["Enchanting"]] = "Enchanting",
	[BTS["Engineering"]] = "Engineering",
	[BTS["First Aid"]] = "First Aid",
	[BTS["Jewelcrafting"]] = "Jewelcrafting",
	[BTS["Leatherworking"]] = "Leatherworking",
	[BTS["Tailoring"]] = "Tailoring",
}
local playerTrades = {}
local guildTrades = {}
local options
options = {
	type = "group",
	args = {
		search = {
		    type = "text",
			name = "Search",
			desc = "Search",
			usage = "<item name>",
			get = false,
			set = "ItemSearch",
			validate = function(text) return (text:len() > 0) end,
			order = 101
		},
		searchResults = {
		    type = "group",
		    name = "Search Results",
		    desc = "SearchResults",
		    args = {},
    		disabled = function()
				return not next(options.args.searchResults.args)
			end,
			order = 102,
		},
		request = {
			type = "execute",
			name = "Request Trade Skills",
			desc = "Request all trade skills",
			func = function()
				 GuildTradeSkills:SendTradeInfo("t")
			end,
			order = 103,
		},
		header = {
			type = "header",
			name = "Trade Skills",
			order = 104
		},
		["Alchemy"] = {
			type = "group",
			name = BTS["Alchemy"],
			desc = BTS["Alchemy"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Alchemy"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Alchemy"]),
			        desc = format("Request %s Trade Skills", BTS["Alchemy"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Alchemy")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Blacksmithing"] = {
			type = "group",
			name = BTS["Blacksmithing"],
			desc = BTS["Blacksmithing"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Blacksmithing"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Blacksmithing"]),
			        desc = format("Request %s Trade Skills", BTS["Blacksmithing"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Blacksmithing")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Cooking"] = {
			type = "group",
			name = BTS["Cooking"],
			desc = BTS["Cooking"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Cooking"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Cooking"]),
			        desc = format("Request %s Trade Skills", BTS["Cooking"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Cooking")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Enchanting"] = {
			type = "group",
			name = BTS["Enchanting"],
			desc = BTS["Enchanting"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Enchanting"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Enchanting"]),
			        desc = format("Request %s Trade Skills", BTS["Enchanting"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Enchanting")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Engineering"] = {
			type = "group",
			name = BTS["Engineering"],
			desc = BTS["Engineering"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Engineering"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Engineering"]),
			        desc = format("Request %s Trade Skills", BTS["Engineering"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Engineering")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["First Aid"] = {
			type = "group",
			name = BTS["First Aid"],
			desc = BTS["First Aid"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["First Aid"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["First Aid"]),
			        desc = format("Request %s Trade Skills", BTS["First Aid"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "First Aid")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Jewelcrafting"] = {
			type = "group",
			name = BTS["Jewelcrafting"],
			desc = BTS["Jewelcrafting"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Jewelcrafting"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Jewelcrafting"]),
			        desc = format("Request %s Trade Skills", BTS["Jewelcrafting"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Jewelcrafting")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Leatherworking"] = {
			type = "group",
			name = BTS["Leatherworking"],
			desc = BTS["Leatherworking"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Leatherworking"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Leatherworking"]),
			        desc = format("Request %s Trade Skills", BTS["Leatherworking"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Leatherworking")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
		["Tailoring"] = {
			type = "group",
			name = BTS["Tailoring"],
			desc = BTS["Tailoring"],
			args = {
			    title = {
			        type = "header",
			        name = BTS["Tailoring"],
			        order = 101
			    },
			    request = {
			        type = "execute",
			        name = format("Request %s Trade Skills", BTS["Tailoring"]),
			        desc = format("Request %s Trade Skills", BTS["Tailoring"]),
			        func = function()
				 		GuildTradeSkills:SendTradeInfo("t", "Tailoring")
			        end,
			        order = 102
			    },
			    header = {
			        type = "header",
			        name = "Trade Items",
					order = 103
			    },
			},
			order = 105
		},
	},
	handler = GuildTradeSkills,
}

local function SendTradeSkillInfo(...)
    GuildTradeSkills:SendCommMessage("GUILD", "s", ...)
    --GuildTradeSkills:OnCommReceive(GuildTradeSkills.commPrefix, UnitName("player"), "GUILD", "s", ...)
end

local function SendTradeSkillItems(tradeInfo)
	if not tradeInfo then return end
	if (type(tradeInfo) == "table") then
		local var = 1
		while (var <= #tradeInfo) do
			SendTradeSkillInfo(unpack(tradeInfo, var, var+18))
			var = var + 19
		end
		return
	elseif (type(tradeInfo) == "number") then
		return SendTradeSkillInfo(tradeInfo)
	end
end

local function SendTradeSkill(tradeSkill)
	local tradeInfo = {}
	for itemId, itemTradeSkill in pairs(playerTrades) do
		if not tradeSkill or (itemTradeSkill == tradeSkill) then
			table.insert(tradeInfo, itemId)
		end
	end
	SendTradeSkillItems(tradeInfo)
end

function GuildTradeSkills:OnInitialize()
--  FuBarPlugin Setup
	self.defaultMinimapPosition = 240
	self.defaultPosition        = "RIGHT"
	self.OnMenuRequest          = options

--  Console Setup
	self:RegisterChatCommand({"/GuildTradeSkills", "/gts"}, options)
	
	self:SetCommPrefix("GTS")
	self:SetDefaultCommPriority("BULK")
end

function GuildTradeSkills:OnEnable()
	TradeSkillFrame_LoadUI()

	self:RegisterComm(self.commPrefix, "GUILD")
	self:RegisterEvent("TRADE_SKILL_SHOW", "UpdateTradeSkill")
	self:RegisterBucketEvent("GuildTradeSkills_UpdateList", 0.5, "UpdateTradeSkillList")
end

function GuildTradeSkills:OnDisable()
end

function GuildTradeSkills:OnCommReceive(prefix, sender, distribution, info, ...)
	if not (prefix == self.commPrefix) then return end
	if (info == "i") or (info == "t") then
		self:SendTradeInfo(info, ...)
	elseif (info == "s") then
		if not guildTrades[sender] then guildTrades[sender] = {} end
		for i=1, select("#", ...) do
			local itemId = select(i, ...)
			if itemId then
				guildTrades[sender][itemId] = true
			end
		end
		self:TriggerEvent("GuildTradeSkills_UpdateList", sender)
	end
end

function GuildTradeSkills:SendTradeInfo(info, ...)
	if (info == "i") then
	    local args = {...}
		for i=1, #args do
			local itemId = args[i]
			if not playerTrades[itemId] then
				table.remove(args, i)
			end
		end
		return SendTradeSkillItems(args)
	elseif (info == "t") then
		return SendTradeSkill(...)
	end
end

function GuildTradeSkills:ItemSearch(text)
    options.args.searchResults.args = {}
    text = text:gsub("(%s+)", ".*")
	for sender, items in pairs(guildTrades) do
		for itemId in pairs(items) do
			local itemName,itemLink, _, _, _, _, _, _, _, itemTexture= GetItemInfo(itemId)
		    if itemName then
				if itemName:find(text) then
			        if not options.args.searchResults.args[itemId] then
						options.args.searchResults.args[itemId] = {
			            	type = "group",
			            	name = itemLink,
			            	desc = itemLink,
			            	args = {},
			            	pass = true,
			            	func = "CrafterClick",
			        		disabled = function()
								return not next(options.args.searchResults.args[itemId].args)
							end,
							icon = itemTexture,
			        	}
					end
					options.args.searchResults.args[itemId].args[sender] = {
		            	type = "execute",
		            	name = sender,
		            	desc = sender,
		        	}
			    end
		    end
		end
	end
end

function GuildTradeSkills:UpdateTradeSkills()
	TradeSkillFrame:UnregisterEvent("TRADE_SKILL_UPDATE")
	for tradeSkill in pairs(tradeSkills) do
		CastSpellByName(tradeSkill)
	end
	CloseTradeSkill()
	TradeSkillFrame:RegisterEvent("TRADE_SKILL_UPDATE")
end

function GuildTradeSkills:UpdateTradeSkill()
	local tradeSkillName = tradeSkills[GetTradeSkillLine()]
	for i=1, GetNumTradeSkills() do
		local itemLink = GetTradeSkillItemLink(i)
		if itemLink then
			itemLink = tonumber(itemLink:match("item:(%d+)"))
			playerTrades[itemLink] = tradeSkillName
		end
	end
end

function GuildTradeSkills:CrafterClick(crafter)
end

function GuildTradeSkills:UpdateTradeSkillList(senders)
	for sender in pairs(senders) do
		for itemId in pairs(guildTrades[sender]) do
			local itemName,itemLink, _, _, _, _, _, _, _, itemTexture= GetItemInfo(itemId)
			local value, path = PT:ItemInSet(itemId, "TradeskillResultMats.Forward")
			if value and path then
				local tradeSkill = path:match("TradeskillResultMats%.Forward%.(.+)%.+") or path:match("TradeskillResultMats%.Forward%.(.+)")
				if not options.args[tradeSkill].args[itemId] or ((guildTrades[sender][itemId] == true) and itemName) then
					options.args[tradeSkill].args[itemId] = {
						type = "group",
						name = itemLink or format("|cffff0000[%d]|r", itemId),
						desc = itemLink or format("|cffff0000[%d]|r", itemId),
						args = {
						    title = {
								type = "header",
								name = itemName or format("|cffff0000[%d]|r", itemId),
								order = 101,
						    },
							request = {
								type = "execute",
								name = "Request Item",
								desc = "Request Item",
								func = function()
								    self:SendTradeInfo("i", itemId)
								end,
								order = 102,
							},
							crafters = {
							    type = "group",
							    name = "Crafters",
							    desc = "Crafters",
							    args = {},
							    pass = true,
				        		func = "CrafterClick",
				        		disabled = function()
									return not next(options.args[tradeSkill].args[itemId].args.crafters.args)
								end,
							    order = 103,
							},
							header = {
							    type = "header",
							    name = "Item Reagents",
							    desc = "Item Reagents",
							    order = 104,
							}
						},
						icon = itemTexture,
						order = 103
					}
					for reagentId, num in string.gmatch(value, "(%d+)x(%d+)") do
					    local _,reagentLink, _, _, _, _, _, _, _, reagentTexture = GetItemInfo(reagentId)
					    options.args[tradeSkill].args[itemId].args[reagentId] = {
					        type = "execute",
					        name = format("%sx%d",reagentLink or format("|cffff0000[%d]|r", reagentId), num),
					        desc = format("%sx%d",reagentLink or format("|cffff0000[%d]|r", reagentId), num),
					        func = function()
					        end,
					        icon = reagentTexture,
					        order = 105
					    }
					end
					guildTrades[sender][itemId] = itemName or true
				end
				if not options.args[tradeSkill].args[itemId].args.crafters.args[sender] then
					options.args[tradeSkill].args[itemId].args.crafters.args[sender] = {
				        type = "execute",
				        name = sender,
				        desc = sender,
					}
				end
			end
		end
	end
end